/*
 *Copyright (C) 2001  LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef my_application__
#define my_application__

#include <vector>
#include <wx/wx.h>

using namespace std;

extern const wxString version_string;

class sequence;
class my_frame;
class my_main_frame;

class my_application : public wxApp
{
private:
  vector<my_frame*> her_frames;
  my_main_frame* her_main_frame;
  void insert_frame(my_frame& frame);
  void initialize_image() const;

public:
  my_application(void);
  ~my_application();
  void remove_frame(my_frame& frame);
  bool OnInit(void);
  void create_window(void);
  void paint_window(void);
  void new_frame(sequence& seq, int buffer_size);
  int get_nb_frames() const;
  my_frame* get_frame(int nb) const;
  void find_sequence_extension_and_create_new_frame(vector<wxString> filenames,
						    int width, int height, int buffer_size);
  void analyse_command_line(int argc, char **argv);
  void set_size_with_dialog(long& width, long& height, wxString sequence_name);
};

#endif
