/*
 *Copyright (C) 2001  LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <iostream>

#include <wx/valtext.h>

#include "my_dialog_save.hh"

using namespace std;

my_dialog_save::my_dialog_save( wxWindow *parent, const wxString& title,
                    const wxPoint& pos, const wxSize& size, const long WXUNUSED(style)) :
  wxDialog(parent, VALIDATE_DIALOG_ID, title, pos, size, wxTE_PROCESS_ENTER|wxTE_PROCESS_TAB |wxDIALOG_MODAL)
{
  this->SetAutoLayout(TRUE);

  wxButton* button_ok = new wxButton(this, wxID_OK, "OK",
				     wxPoint(-1,-1),
				     wxSize(-1, -1));

  wxButton* button_cancel= new wxButton(this, wxID_CANCEL, "Cancel",
					wxPoint(0,0),
					wxSize(-1, -1));

  TextCtrlName=new wxTextCtrl(this, VALIDATE_NAME, "",
			       wxPoint(-1,-1),
			       wxSize(-1, -1), 0,
			       wxTextValidator(wxFILTER_NONE, &name_of_file));

  wxStaticText* static_name=new wxStaticText(this, -1, "Nom du fichier : ",
					     wxPoint(-1, -1), wxDefaultSize,
					     wxALIGN_LEFT);



  wxLayoutConstraints *layout_static_name_file=new wxLayoutConstraints;
  layout_static_name_file->left.SameAs       (this, wxLeft, 10);
  layout_static_name_file->top.SameAs        (this,wxTop, 10);
  layout_static_name_file->width.PercentOf   (this, wxWidth, 40);
  layout_static_name_file->height.PercentOf  (this, wxHeight, 20);
  static_name->SetConstraints(layout_static_name_file);

  wxLayoutConstraints *layout_static_name=new wxLayoutConstraints;
  layout_static_name->left.SameAs       (static_name, wxRight, 10);
  layout_static_name->top.SameAs        (this,wxTop, 10);
  layout_static_name->width.PercentOf   (this, wxWidth, 50);
  layout_static_name->height.PercentOf  (this, wxHeight, 20);
  TextCtrlName->SetConstraints(layout_static_name);


  wxLayoutConstraints *layout_ok=new wxLayoutConstraints;
  layout_ok->left.SameAs       (this, wxLeft, 10);
  layout_ok->top.Below        ( TextCtrlName, 10);
  layout_ok->width.PercentOf   (this, wxWidth, 20);
  layout_ok->height.PercentOf  (this, wxHeight, 20);
  button_ok->SetConstraints(layout_ok);

  wxLayoutConstraints *layout_cancel=new wxLayoutConstraints;
  layout_cancel->top.Below        ( TextCtrlName, 10);
  layout_cancel->width.PercentOf   (this, wxWidth, 20);
  layout_cancel->height.PercentOf  (this, wxHeight, 20);
  layout_cancel->left.RightOf(button_ok,5);
  button_cancel->SetConstraints(layout_cancel);


  button_ok->SetFocus();
  button_ok->SetDefault();
}
