/*
 *Copyright (C) 2001   LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef my_frame__
#define my_frame__

#include <vector>

#include <wx/wx.h>
#include <wx/image.h>
#include <wx/dynarray.h>
#include <wx/spinbutt.h>

#include "common_type.hh"

class buffer;
class my_thread_paint;
class my_thread_process;
class my_thread_load;
class my_main_frame;
class sequence;

class my_frame : public wxFrame
{
private:
  my_thread_load* her_thread_load;
  my_thread_process* her_thread_process;

  sequence* her_sequence;
  my_main_frame* my_mother;
  buffer* her_buffer;

  bool is_readed; //pour savoir si tous les frames sont  la mme position
  type_of_current_reading local_type_of_current_reading;
  int long zoom;

  // widgets

  wxSpinButton* child_spinbutton_position;
  wxSlider* m_slider;
  wxScrolledWindow* draw_frame;

  enum local_control{ID_LOCAL_TBAR,
		     ID_SLIDER,
		     ID_TEST,
		     ID_BUTTON_ZOOM,
		     ID_SPIN_BUTTON_POSITION,ID_BUTTON_SAVE};

public:

  my_frame(wxFrame* parent, const wxString& title,
	   const wxPoint& pos, const wxSize& size,
	   my_main_frame& my_mother,sequence& seq,
	   int buffer_size);

  ~my_frame();

  void create_threads();
  void create_local_video_tbar();
  void draw_bitmap();

  void set_current_position(long int new_position);
  void set_current_position(type_of_current_reading cr);
  void set_new_current_position();
  void set_current_loading_position(int new_position);
  void set_local_type_of_current_reading(type_of_current_reading cr);
  void set_is_readed(bool val);
  void set_slider_position(int position);

  sequence* get_sequence();
  type_of_current_reading get_type_of_current_reading();
  type_of_current_reading get_mother_type_of_current_reading();
  bool get_is_readed() const;
  int get_current_position() const;
  play_mode get_play_mode() const;
  int long get_zoom() const;

  void OnComboZoom(wxCommandEvent& event);
  void OnCloseWindow(wxCloseEvent& event);
  void OnSlider(wxCommandEvent& WXUNUSED(event));
  void OnPaint(wxPaintEvent& WXUNUSED(event));
  void OnSpin(wxSpinEvent& event);
  void OnSaveImage();

  DECLARE_EVENT_TABLE()
};

#endif
