/*
 *Copyright (C) 2001  Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <vector>
#include <iostream>

#include <wx/event.h>

#include "sequence.hh"
#include "my_thread_load.hh"
#include "buffer.hh"
#include "sequence.hh"

using namespace std;

my_thread_load::my_thread_load(my_frame& frame,buffer& buf,sequence& seq) :
  wxThread(wxTHREAD_JOINABLE),
  mother_frame(&frame),
  my_buffer(&buf),
  my_sequence(&seq),
  should_continue(true)
{
}

bool my_thread_load::conditions_for_break(int i,type_of_current_reading cr)
{
  if(mother_frame->get_type_of_current_reading()!=cr ||
     (my_buffer->get_last_position()!=mother_frame->get_current_position() &&
      my_buffer->get_last_position()!=mother_frame->get_current_position()-cr) ||
     my_buffer->get_first_image()>i || my_buffer->get_last_image()<i)
    return true;
  else
    return false;
}

void* my_thread_load::Entry()
{
  while(should_continue)
  {
    my_buffer->initialize_condition();
    switch(mother_frame->get_type_of_current_reading())
    {
    case PLAY_BACKWARD:
      int k;
      int l;
      k=my_buffer->get_current_loaded_image();
      l=my_buffer->get_first_image();
      while(k>=l)
      {
	if(conditions_for_break(k,PLAY_BACKWARD))
	  break;

	if(my_buffer->image_not_existing(k))
	  my_buffer->put_image(k,*my_sequence->load(k));

	my_buffer->set_current_loaded_image(k);
	k--;
      }
      break;

    case PLAY_FORWARD:
      int i;
      int j;
      i=my_buffer->get_current_loaded_image();
      j=my_buffer->get_last_image();
      while(i<=j)
      {
	if(conditions_for_break(i,PLAY_FORWARD))
	  break;

	if(my_buffer->image_not_existing(i))
	  my_buffer->put_image(i,*my_sequence->load(i));

	my_buffer->set_current_loaded_image(i);
	i++;
      }
      break;

    case IMAGE_FORWARD:
    case IMAGE_BACKWARD:
      if(my_buffer->image_not_existing(my_buffer->get_current_loaded_image()))
      {
	my_buffer->put_image(my_buffer->get_current_loaded_image(),
			     *my_sequence->load(my_buffer->get_current_loaded_image()));
      }
      break;

    case UN_INITIALIZED:
    default:break;
    }
    //cout << "ATTEND" << endl;
    my_buffer->load_thread_you_can_load->Wait();
  }
  cout << "sortie de boucle" << endl;

  return 0;
}

void my_thread_load::OnExit()
{}
