/*
 *Copyright (C) 2001  Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <iostream>

#include "my_thread_process.hh"
#include "sequence.hh"
#include "buffer.hh"
#include "sequence.hh"

using namespace std;

my_thread_process::my_thread_process(my_frame& frame,buffer& buf,sequence& seq) :
  wxThread()
{

  mother_frame=&frame;
  my_buffer=&buf;
  my_sequence=&seq;
  should_continue=true;
  data=0;
  data_images=(unsigned char**)malloc(my_buffer->get_buffer_size());
}

bool my_thread_process::conditions_for_break(int /*i*/, type_of_current_reading cr)
{
  if(mother_frame->get_type_of_current_reading()!=cr ||
     (my_buffer->get_last_position()!=mother_frame->get_current_position() &&
      my_buffer->get_last_position()!=mother_frame->get_current_position()-cr)
     /*|| my_buffer->get_first_image()>i || my_buffer->get_last_image()<i*/)
  {
    //cout << "CONDITIONS BREAK\n";
    return true;
  }
  else
  {
    return false;
  }
}

void* my_thread_process::Entry()
{
  while(true)
  {
    my_buffer->initialize_condition_process();
    //cout << "initialisation condition process\n";
    switch(mother_frame->get_type_of_current_reading())
    {
    case PLAY_BACKWARD:
      int k;
      int l;
      k=my_buffer->get_current_process_image();
      l=my_buffer->get_current_loaded_image();
      //cout << "dans play_backward de process"<<endl;
      while(k>=l)
      {
	if(conditions_for_break(k,PLAY_BACKWARD))
	break;

	if(my_buffer->get_process_image(k)==0 &&
	   my_buffer->get_image(k)!=0)
	{
	  wxImage *im;
	  int taille=my_sequence->get_width()*
	    my_sequence->get_height()*3;
	  unsigned char *dat;
	  //unsigned char *data;
	  cout << "process 1" <<endl;
	  free(data);
	  data=(unsigned char*)malloc(taille);
	  dat=my_buffer->get_image(k)->GetData();
	  for(int z=0;z<taille;z++)
	  {
	    data[z]=dat[z];
	  }
	  im=(new wxImage(my_sequence->get_width(),
			  my_sequence->get_height(),
			  data,true));
	  im->Rescale(my_sequence->get_width()*mother_frame->get_zoom(),
		      my_sequence->get_height()*mother_frame->get_zoom());
	  my_buffer->put_process_image(k,*im);
	  //cout << "process read\n" << mother_frame->get_zoom() << endl;
	}
	//cout << "PROCESS 1 " << endl;
	my_buffer->set_current_process_image(k);
	k--;
      }
      break;
    case PLAY_FORWARD :
      int i;
      int j;
      i=my_buffer->get_current_process_image();
      j=my_buffer->get_current_loaded_image();
      //cout << "dans play_forward de process"<<endl;
      while(i<=j)
      {
	if(conditions_for_break(i,PLAY_FORWARD))
	break;

	if(my_buffer->get_process_image(i)==0 &&
	   my_buffer->get_image(i)!=0)
	{
	  wxImage *im;
	  int taille=my_sequence->get_width()*
	    my_sequence->get_height()*3;
	  unsigned char *dat;
	  //unsigned char *data;
	  //cout << "process 1" <<endl;
	  free(data);
	  data=(unsigned char*)malloc(taille);
	  dat=my_buffer->get_image(i)->GetData();
	  for(int z=0;z<taille;z++)
	  {
	    data[z]=dat[z];
	  }
	  im=(new wxImage(my_sequence->get_width(),
			  my_sequence->get_height(),
			  data,true));
	  im->Rescale(my_sequence->get_width()*mother_frame->get_zoom(),
		      my_sequence->get_height()*mother_frame->get_zoom());
	  my_buffer->put_process_image(i,*im);
	  //cout << "process read\n" << mother_frame->get_zoom() << endl;
	}
	//cout << "PROCESS 1 " << endl;
	my_buffer->set_current_process_image(i);
	i++;
      }
      break;


    case IMAGE_FORWARD :
    case IMAGE_BACKWARD:
      int current_position;
      current_position=my_buffer->get_last_position();
      if(my_buffer->get_process_image(current_position)==0 ||
	 my_buffer->get_calcul()==2)
      {
	if(my_buffer->get_calcul()==2)
	{
	  my_buffer->set_calcul(1);
	}
	//cout << "process entry" << endl;
	if(my_buffer->get_image(current_position)!=0)
	{
	  wxImage *im;
	  int taille=my_sequence->get_width()*
	  my_sequence->get_height()*3;
	  unsigned char *dat;
	  free(data);
	  data=(unsigned char*)malloc(taille);
	  dat=my_buffer->get_image(current_position)->GetData();
	  for(int i=0;i<taille;i++)
	  {
	    data[i]=dat[i];
	  }
	  im=new wxImage(my_sequence->get_width(),
			 my_sequence->get_height(),
			 data,true);
	  //im=new wxImage(*my_buffer->get_image(current_position));
	  im->Rescale(my_sequence->get_width()*mother_frame->get_zoom(),
		      my_sequence->get_height()*mother_frame->get_zoom());
	  my_buffer->put_process_image(current_position,*im);
	  //cout << "process\n" << mother_frame->get_zoom() << endl;
	}
      }
      //cout << "process2\n" << endl;
      break;

    case UN_INITIALIZED:
    default:
      cout << "Warning : default in switch"<<endl;
      break;
    }
    my_buffer->thread_process_you_can_process->Wait();
  }
  return 0;
}

void my_thread_process::OnExit()
{
}
