/*
 *Copyright (C) 2001  LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <wx/wx.h>
#include <wx/file.h>

#include "sequence.hh"

sequence::sequence(const vector<wxString> files_names) :
  name_of_the_images(files_names),
  type_of_file(name_of_the_images[0].AfterLast('.')),
  width(0),
  height(0),
  size(calcul_size()),
  start_position(0),
  final_position(0),
  nb_pictures(0),
  current_position(0)
{
}

sequence::sequence()
{
}

wxString sequence::get_name(int number) const
{
  return name_of_the_images[number];
}

int sequence::get_width() const
{
  return width;
}

int sequence::get_height() const
{
  return height;
}

wxString sequence::get_file_type() const
{
  return type_of_file;
}

int sequence::get_size() const
{
  return size;
}

int sequence::get_nb_pictures() const
{
  return nb_pictures;
}

int sequence::get_current_position() const
{
  return current_position;
}

int sequence::get_start_position() const
{
  return start_position;
}

vector<wxString> sequence::get_name_vector() const
{
  return name_of_the_images;
}

int sequence::get_final_position() const
{
  return final_position;
}

void sequence::set_width(int width)
{
  this->width=width;
}

void sequence::set_height(int height)
{
  this->height=height;
}

void sequence::set_size(int size)
{
  this->size=size;
}

void sequence::set_nb_pictures(int nb)
{
  nb_pictures=nb;
}

void sequence::set_current_position(int position)
{
  if(position>get_nb_pictures())
    current_position=get_nb_pictures();
  //else if(position<get_start_position())
  //current_position=get_start_position();
  else
    current_position=position;
}

void sequence::set_start_position(int position)
{
  start_position=position;
}

void sequence::set_final_position(int position)
{
  final_position=position;
}

long int sequence::calcul_size()
{
  int taille;
  wxFile file;
  file.Open(this->name_of_the_images[0],wxFile::read);
  taille=file.Length();
  file.Close();
  return taille;
}

sequence::~sequence()
{}
