/*
 *Copyright (C) 2001  LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef sequence__
#define sequence__

#include <vector>

#include <wx/wx.h>
#include <wx/image.h>

using namespace std;

class sequence
{
protected:
  /* indices vary from 0 to nb_pictures-1*/
  vector<wxString> name_of_the_images;
  wxString type_of_file;
  int width;
  int height;
  int size;
  int start_position;
  int final_position;
  int nb_pictures;
  /* for the display */
  int current_position;
public:
  sequence(const vector<wxString> files_names);
  sequence();
  wxString get_name(int number) const;
  wxString get_file_type() const;
  int get_width() const;
  int get_height() const;
  int get_size() const;
  int get_nb_pictures() const;
  int get_current_position() const;
  int get_start_position() const;
  int get_final_position() const;
  vector<wxString> get_name_vector() const;

  void set_width(int width);
  void set_height(int height);
  void set_size(int size);
  void set_nb_pictures(int nb);
  void set_current_position(int position);
  void set_start_position(int position);
  void set_final_position(int position);

  long int calcul_size();
  virtual wxImage* load(int position)=0;
  virtual ~sequence();
  virtual bool must_free_data_image() const=0;
};

#endif
