/*
 *Copyright (C) 2001   LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <iostream>

#include <wx/wx.h>
#include <wx/file.h>

#include "sequence_pgm.hh"

using namespace std;

sequence_pgm::sequence_pgm(vector<wxString> filenames) :
  sequence(filenames)
{
  find_and_set_attributes();
  start_position=return_indice_first(name_of_the_images[0]);
  nb_pictures+=start_position;
  set_current_position(get_start_position());
}

bool sequence_pgm::must_free_data_image() const
{
  return true;
}

void sequence_pgm::find_and_set_attributes()
{
  FILE *file;
  char c;
  wxString width_tmp;
  wxString height_tmp;
  file=fopen(name_of_the_images[1].c_str(),"r");

  c=getc(file);
  while(c!='\n')
  {
    c=getc(file);
  }

  int i=0;
  while(c!=' ')
  {
    c=getc(file);
    width_tmp.Append((wxString)c);
  }

  i=0;
  while(c!='\n')
  {
    c=getc(file);
    height_tmp.Append((wxString)c);
  }

  width=atoi(width_tmp.c_str());
  height=atoi(height_tmp.c_str());
  nb_pictures=name_of_the_images.size();
  start_position=0;
  final_position=nb_pictures-1;
  cout << "height : " << height << " width : " << width << endl;
  fclose(file);
}

wxImage* sequence_pgm::load(int position)
{
  if(position<get_start_position())
  {
    wxImage *image;
    long int taille=get_height()*get_width();
    unsigned char* tab=(unsigned char*)malloc(taille*3);
     for(int i=0;i<taille*3;i++)
    {
      tab[i]=0;
    }
     image = new wxImage(get_width(), get_height(), tab, TRUE);
    return image;
  }
  else
  {
    FILE *file;
    wxImage *image;
    char c=0;
    int nombre_de_ligne;
    long int taille=get_height()*get_width();
    position-=get_start_position();
    file=fopen(get_name(position).c_str(),"rb");
    vector<unsigned char> PGM(taille);
    unsigned char* tab=(unsigned char*)malloc(taille*3);
    nombre_de_ligne=0;
    while(c!='\n' || nombre_de_ligne!=3)
    {
      c=(char)getc(file);
      if(c=='\n')
	nombre_de_ligne++;
      //cout << c << endl;
    }

    fread(&PGM[0], taille, sizeof(unsigned char), file);
    fclose(file);

    for(int i=0;i<taille*3;i++)
    {
      tab[i]=PGM[i/3];
    }

    image = new wxImage(get_width(), get_height(), tab, TRUE);
    //cout << "pointeur image : " << image << endl;
    return image;
  }
}

int sequence_pgm::return_indice_first(wxString filename)
{
  wxString number;
  long num;
  for(int i=0;i<(int)filename.Len();i++)
  {
    if(filename.SubString(i,i).IsNumber())
    {
      number+=filename.SubString(i,i);
    }
  }
  number.ToLong(&num);
  return (int)num;
}
