/*
 *Copyright (C) 2001   LIS Laboratory Yann Davin
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <iostream>

#include <wx/wx.h>
#include <wx/file.h>

#include "sequence_wxformat.hh"

sequence_wxformat::sequence_wxformat(vector<wxString> filenames) : sequence(filenames)
{
  size=calcul_size();
  nb_pictures=name_of_the_images.size();
  start_position=return_indice_first(name_of_the_images[0]);
  nb_pictures+=start_position;
  cout << "wxFORMAT" << nb_pictures << endl;
  final_position=nb_pictures;
  find_and_fix_height_and_width();
}

sequence_wxformat::sequence_wxformat(wxString /*first_filename*/)
{
}

void sequence_wxformat::find_and_fix_height_and_width()
{
  wxBitmap bitmap(name_of_the_images[0],wxBITMAP_TYPE_ANY);
  cout << "W  : " << bitmap.GetWidth()<<endl;
  cout << "H  : " << bitmap.GetHeight()<<endl;
  width=bitmap.GetWidth();
  height=bitmap.GetHeight();
}

wxImage* sequence_wxformat::load(int position)
{
  if(position<get_start_position())
  {
    return 0;
  }
  else
  {
    position-=get_start_position();
    if(position<get_nb_pictures())
    {
      //cout << "image load : " <<  get_name(position) << endl;
      return new wxImage(get_name(position),wxBITMAP_TYPE_ANY);
    }
    else
    {
      //cout << "image load superieur"<<endl;
      return 0;
    }
  }
}

bool sequence_wxformat::must_free_data_image() const
{
  return false;
}

int sequence_wxformat::return_indice_first(wxString filename)
{
  wxString number;
  long num;
  for(int i=0;i<(int)filename.Len();i++)
  {
    if(filename.SubString(i,i).IsNumber())
    {
      number+=filename.SubString(i,i);
    }
  }
  number.ToLong(&num);
  return (int)num;
}
