void YUV2RGB(unsigned char y,unsigned char u,
	     unsigned char v,unsigned  char r,
	     unsigned  char g,unsigned char b)
{
  r=y+(((v<<10)+(v<<8)+(v<<7)+(v<<4)+(v<<3)+(v<<1))>>11);
  g=y-((((u<<8)+(u<<7)+(u<<4)+(u<<2)+(u<<1))-((v<<9)+(v<<6)+(v<<4)+(v<<1)+v))>>11);
  b=y+(((u<<11)+(u<<5)-(u<<1))>>11);
  r=r<0 ? 0:r;
  g=g<0 ? 0:g;
  b=b<0 ? 0:b;
  r=r>255 ? 255:r;
 g=g>255 ? 255:g;
 b=b>255 ? 255:b;
}

inline void util_1394_yuv444torgb (char *YUV, char *RGB, int NumPixels)
{
  int i;
  register int y, u, v;
  register int r, g, b;

  for (i = 0; i < (NumPixels << 1); i += 3)
  {
    u = (unsigned char) YUV[i + 0] - 128;
    y = (unsigned char) YUV[i + 1];
    v = (unsigned char) YUV[i + 2] - 128;
    YUV2RGB (y, u, v, r, g, b);
    RGB[i + 0] = r;
    RGB[i + 1] = g;
    RGB[i + 2] = b;
  }
}


inline void util_1394_yuv422torgb (char *YUV, char *RGB,
				   int NumPixels)
{
  int i, j;
  register int y0, y1, u, v;
  register int r, g, b;

  for (i = 0, j = 0; i < (NumPixels << 1); i += 4, j+=6)
  {
    u = (unsigned char) YUV[i + 0] - 128;
    y0 = (unsigned char) YUV[i + 1];
    v = (unsigned char) YUV[i + 2] - 128;
    y1 = (unsigned char) YUV[i + 3];
    YUV2RGB (y0, u, v, r, g, b);
    RGB[j + 0] = r;
    RGB[j + 1] = g;
    RGB[j + 2] = b;
    YUV2RGB (y1, u, v, r, g, b);
    RGB[j + 3] = r;
    RGB[j + 4] = g;
    RGB[j + 5] = b;
  }
}


inline void util_1394_yuv411torgb (char *YUV, char *RGB,
				   int NumPixels)
{
  int i, j;
  register int y0, y1, y2, y3, u, v;
  register int r, g, b;

  for (i = 0, j = 0;
       i<(NumPixels +  (NumPixels >> 1));
       i += 6, j += 12)
  {
    u  = (unsigned char) YUV[i + 0] - 128;
    y0 = (unsigned char) YUV[i + 1];
    y1 = (unsigned char) YUV[i + 2];
    v  = (unsigned char) YUV[i + 3] - 128;
    y2 = (unsigned char) YUV[i + 4];
    y3 = (unsigned char) YUV[i + 5];
    YUV2RGB (y0, u, v, r, g, b);
    RGB[j + 0] = r;
    RGB[j + 1] = g;
    RGB[j + 2] = b;
    YUV2RGB (y1, u, v, r, g, b);
    RGB[j + 3] = r;
    RGB[j + 4] = g;
    RGB[j + 5] = b;
    YUV2RGB (y2, u, v, r, g, b);
    RGB[j + 6] = r;
    RGB[j + 7] = g;
    RGB[j + 8] = b;
    YUV2RGB (y3, u, v, r, g, b);
    RGB[j + 9] = r;
    RGB[j + 10] = g;
    RGB[j + 11] = b;
  }
}
